# SPDX-License-Identifier: GPL-2.0-only OR BSD-2-Clause
%YAML 1.2
---
$id: http://devicetree.org/schemas/net/spacemit,k1-emac.yaml#
$schema: http://devicetree.org/meta-schemas/core.yaml#

title: SpacemiT K1 Ethernet MAC

allOf:
  - $ref: ethernet-controller.yaml#

maintainers:
  - Vivian Wang <wangruikang@iscas.ac.cn>

properties:
  compatible:
    const: spacemit,k1-emac

  reg:
    maxItems: 1

  clocks:
    maxItems: 1

  interrupts:
    maxItems: 1

  mdio-bus:
    $ref: mdio.yaml#
    unevaluatedProperties: false

  resets:
    maxItems: 1

  spacemit,apmu:
    $ref: /schemas/types.yaml#/definitions/phandle-array
    items:
      - items:
          - description: phandle to syscon that controls this MAC
          - description: offset of control registers
    description:
      A phandle to syscon with byte offset to control registers for this MAC

required:
  - compatible
  - reg
  - clocks
  - interrupts
  - resets
  - spacemit,apmu

unevaluatedProperties: false

examples:
  - |
    #include <dt-bindings/clock/spacemit,k1-syscon.h>

    ethernet@cac80000 {
        compatible = "spacemit,k1-emac";
        reg = <0xcac80000 0x00000420>;
        clocks = <&syscon_apmu CLK_EMAC0_BUS>;
        interrupts = <131>;
        mac-address = [ 00 00 00 00 00 00 ];
        phy-handle = <&rgmii0>;
        phy-mode = "rgmii-id";
        pinctrl-names = "default";
        pinctrl-0 = <&gmac0_cfg>;
        resets = <&syscon_apmu RESET_EMAC0>;
        rx-internal-delay-ps = <0>;
        tx-internal-delay-ps = <0>;
        spacemit,apmu = <&syscon_apmu 0x3e4>;

        mdio-bus {
            #address-cells = <0x1>;
            #size-cells = <0x0>;

            rgmii0: phy@1 {
                reg = <0x1>;
            };
        };
    };
